--- //depot/vendor/freebsd/src/sys/net/if_gif.c	2005/07/25 12:35:27
+++ //depot/projects/netsmp/src/sys/net/if_gif.c	2005/08/05 14:11:40
@@ -876,18 +876,18 @@
 		free((caddr_t)odst, M_IFADDR);
 
 	if (sc->gif_psrc && sc->gif_pdst)
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	else
-		ifp->if_flags &= ~IFF_RUNNING;
+		ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	splx(s);
 
 	return 0;
 
  bad:
 	if (sc->gif_psrc && sc->gif_pdst)
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	else
-		ifp->if_flags &= ~IFF_RUNNING;
+		ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	splx(s);
 
 	return error;
@@ -919,8 +919,8 @@
 #endif
 
 	if (sc->gif_psrc && sc->gif_pdst)
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	else
-		ifp->if_flags &= ~IFF_RUNNING;
+		ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	splx(s);
 }
--- //depot/vendor/freebsd/src/sys/net/if_gre.c	2005/08/01 08:18:15
+++ //depot/projects/netsmp/src/sys/net/if_gre.c	2005/08/05 14:11:40
@@ -257,7 +257,8 @@
 		goto end;
 	}
 
-	if ((ifp->if_flags & (IFF_UP | IFF_RUNNING)) == 0 ||
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)) ||
 	    sc->g_src.s_addr == INADDR_ANY || sc->g_dst.s_addr == INADDR_ANY) {
 		m_freem(m);
 		error = ENETDOWN;
@@ -559,9 +560,9 @@
 			if (sc->route.ro_rt != 0) /* free old route */
 				RTFREE(sc->route.ro_rt);
 			if (gre_compute_route(sc) == 0)
-				ifp->if_flags |= IFF_RUNNING;
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 			else
-				ifp->if_flags &= ~IFF_RUNNING;
+				ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 		}
 		break;
 	case GREGADDRS:
--- //depot/vendor/freebsd/src/sys/net/if_iso88025subr.c	2005/08/02 17:55:56
+++ //depot/projects/netsmp/src/sys/net/if_iso88025subr.c	2005/08/05 14:11:40
@@ -253,7 +253,8 @@
 
 	if (ifp->if_flags & IFF_MONITOR)
 		senderr(ENETDOWN);
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		senderr(ENETDOWN);
 	getmicrotime(&ifp->if_lastchange);
 
@@ -483,7 +484,8 @@
 	/*
 	 * Discard packet if interface is not up.
 	 */
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		goto dropanyway;
 
 	/*
--- //depot/vendor/freebsd/src/sys/net/if_loop.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/net/if_loop.c	2005/08/05 14:11:40
@@ -349,7 +349,8 @@
 	switch (cmd) {
 
 	case SIOCSIFADDR:
-		ifp->if_flags |= IFF_UP | IFF_RUNNING;
+		ifp->if_flags |= IFF_UP;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		ifa = (struct ifaddr *)data;
 		ifa->ifa_rtrequest = lortrequest;
 		/*
--- //depot/vendor/freebsd/src/sys/net/if_ppp.c	2005/07/05 23:40:38
+++ //depot/projects/netsmp/src/sys/net/if_ppp.c	2005/08/05 14:11:40
@@ -404,7 +404,8 @@
     struct mbuf *m;
 
     if_down(PPP2IFP(sc));
-    PPP2IFP(sc)->if_flags &= ~(IFF_UP|IFF_RUNNING);
+    PPP2IFP(sc)->if_flags &= ~IFF_UP;
+    PPP2IFP(sc)->if_drv_flags &= ~IFF_DRV_RUNNING;
     getmicrotime(&PPP2IFP(sc)->if_lastchange);
     sc->sc_devp = NULL;
     sc->sc_xfer = 0;
@@ -688,7 +689,7 @@
 
     switch (cmd) {
     case SIOCSIFFLAGS:
-	if ((ifp->if_flags & IFF_RUNNING) == 0)
+	if ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0)
 	    ifp->if_flags &= ~IFF_UP;
 	break;
 
@@ -822,7 +823,7 @@
 	goto bad;
 #endif
 
-    if (sc->sc_devp == NULL || (ifp->if_flags & IFF_RUNNING) == 0
+    if (sc->sc_devp == NULL || (ifp->if_drv_flags & IFF_DRV_RUNNING) == 0
 	|| ((ifp->if_flags & IFF_UP) == 0 && dst->sa_family != AF_UNSPEC)) {
 	error = ENETDOWN;	/* sort of */
 	goto bad;
--- //depot/vendor/freebsd/src/sys/net/if_spppsubr.c	2005/07/25 12:35:27
+++ //depot/projects/netsmp/src/sys/net/if_spppsubr.c	2005/08/05 14:11:40
@@ -839,8 +839,9 @@
 	s = splimp();
 	SPPP_LOCK(sp);
 
-	if ((ifp->if_flags & IFF_UP) == 0 ||
-	    (ifp->if_flags & (IFF_RUNNING | IFF_AUTO)) == 0) {
+	if (!(ifp->if_flags & IFF_UP) ||
+	    (!(ifp->if_flags & IFF_AUTO) &&
+	    !(ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 #ifdef INET6
 	  drop:
 #endif
@@ -850,7 +851,8 @@
 		return (ENETDOWN);
 	}
 
-	if ((ifp->if_flags & (IFF_RUNNING | IFF_AUTO)) == IFF_AUTO) {
+	if ((ifp->if_flags & IFF_AUTO) &&
+	    !(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 #ifdef INET6
 		/*
 		 * XXX
@@ -868,7 +870,7 @@
 		 * Interface is not yet running, but auto-dial.  Need
 		 * to start LCP for it.
 		 */
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		splx(s);
 		lcp.Open(sp);
 		s = splimp();
@@ -1268,9 +1270,9 @@
 
 	case SIOCSIFFLAGS:
 		going_up = ifp->if_flags & IFF_UP &&
-			(ifp->if_flags & IFF_RUNNING) == 0;
+			(ifp->if_drv_flags & IFF_DRV_RUNNING) == 0;
 		going_down = (ifp->if_flags & IFF_UP) == 0 &&
-			ifp->if_flags & IFF_RUNNING;
+			ifp->if_drv_flags & IFF_DRV_RUNNING;
 
 		newmode = ifp->if_flags & IFF_PASSIVE;
 		if (!newmode)
@@ -1286,7 +1288,7 @@
 		if (newmode != sp->pp_mode) {
 			going_down = 1;
 			if (!going_up)
-				going_up = ifp->if_flags & IFF_RUNNING;
+				going_up = ifp->if_drv_flags & IFF_DRV_RUNNING;
 		}
 
 		if (going_down) {
@@ -1296,7 +1298,7 @@
 			else if (sp->pp_tlf)
 				(sp->pp_tlf)(sp);
 			sppp_flush_unlocked(ifp);
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 			sp->pp_mode = newmode;
 		}
 
@@ -1306,14 +1308,14 @@
 				lcp.Close(sp);
 			sp->pp_mode = newmode;
 			if (sp->pp_mode == 0) {
-				ifp->if_flags |= IFF_RUNNING;
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 				lcp.Open(sp);
 			}
 			if ((sp->pp_mode == IFF_CISCO) ||
 			    (sp->pp_mode == PP_FR)) {
 				if (sp->pp_tls)
 					(sp->pp_tls)(sp);
-				ifp->if_flags |= IFF_RUNNING;
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 			}
 		}
 
@@ -1428,7 +1430,7 @@
 		}
 		sp->pp_loopcnt = 0;
 		if (! (ifp->if_flags & IFF_UP) &&
-		    (ifp->if_flags & IFF_RUNNING)) {
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 			if_up(ifp);
 			printf (SPP_FMT "up\n", SPP_ARGS(ifp));
 		}
@@ -2268,7 +2270,7 @@
 		if (debug)
 			log(LOG_DEBUG,
 			    SPP_FMT "Up event", SPP_ARGS(ifp));
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		if (sp->state[IDX_LCP] == STATE_INITIAL) {
 			if (debug)
 				log(-1, "(incoming call)\n");
@@ -2278,7 +2280,7 @@
 			log(-1, "\n");
 	} else if ((ifp->if_flags & (IFF_AUTO | IFF_PASSIVE)) == 0 &&
 		   (sp->state[IDX_LCP] == STATE_INITIAL)) {
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		lcp.Open(sp);
 	}
 
@@ -2312,7 +2314,7 @@
 		sp->pp_flags &= ~PP_CALLIN;
 		if (sp->state[IDX_LCP] != STATE_INITIAL)
 			lcp.Close(sp);
-		ifp->if_flags &= ~IFF_RUNNING;
+		ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	}
 }
 
@@ -2718,7 +2720,7 @@
 
 	/* XXX ? */
 	if (! (ifp->if_flags & IFF_UP) &&
-	    (ifp->if_flags & IFF_RUNNING)) {
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 		/* Coming out of loopback mode. */
 		if_up(ifp);
 		printf (SPP_FMT "up\n", SPP_ARGS(ifp));
@@ -4819,7 +4821,7 @@
 	SPPP_LOCK(sp);
 	/* Keepalive mode disabled or channel down? */
 	if (! (sp->pp_flags & PP_KEEPALIVE) ||
-	    ! (ifp->if_flags & IFF_RUNNING))
+	    ! (ifp->if_drv_flags & IFF_DRV_RUNNING))
 		goto out;
 
 	if (sp->pp_mode == PP_FR) {
--- //depot/vendor/freebsd/src/sys/net/if_tap.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/net/if_tap.c	2005/08/05 14:11:40
@@ -391,8 +391,8 @@
 	mtx_unlock(&tp->tap_mtx);
 
 	s = splimp();
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	splx(s);
 
 	TAPDEBUG("%s is open. minor = %#x\n", ifp->if_xname, minor(dev));
@@ -431,12 +431,12 @@
 		mtx_unlock(&tp->tap_mtx);
 		s = splimp();
 		if_down(ifp);
-		if (ifp->if_flags & IFF_RUNNING) {
+		if (ifp->if_drv_flags & IFF_DRV_RUNNING) {
 			TAILQ_FOREACH(ifa, &ifp->if_addrhead, ifa_link) {
 				rtinit(ifa, (int)RTM_DELETE, 0);
 			}
 			if_purgeaddrs(ifp);
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 		}
 		splx(s);
 	} else
@@ -471,8 +471,8 @@
 
 	TAPDEBUG("initializing %s\n", ifp->if_xname);
 
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	/* attempt to start output */
 	tapifstart(ifp);
@@ -568,7 +568,7 @@
 	mtx_unlock(&tp->tap_mtx);
 
 	s = splimp();
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 
 	if (ifp->if_snd.ifq_len != 0) {
 		mtx_lock(&tp->tap_mtx);
@@ -587,7 +587,7 @@
 		ifp->if_opackets ++; /* obytes are counted in ether_output */
 	}
 
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	splx(s);
 } /* tapifstart */
 
--- //depot/vendor/freebsd/src/sys/net/if_tun.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/net/if_tun.c	2005/08/05 14:11:40
@@ -358,7 +358,7 @@
 		splx(s);
 	}
 
-	if (ifp->if_flags & IFF_RUNNING) {
+	if (ifp->if_drv_flags & IFF_DRV_RUNNING) {
 		struct ifaddr *ifa;
 
 		s = splimp();
@@ -368,7 +368,7 @@
 				/* Unlocked read. */
 				rtinit(ifa, (int)RTM_DELETE,
 				    tp->tun_flags & TUN_DSTADDR ? RTF_HOST : 0);
-		ifp->if_flags &= ~IFF_RUNNING;
+		ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 		splx(s);
 	}
 
@@ -387,7 +387,8 @@
 
 	TUNDEBUG(ifp, "tuninit\n");
 
-	ifp->if_flags |= IFF_UP | IFF_RUNNING;
+	ifp->if_flags |= IFF_UP;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	getmicrotime(&ifp->if_lastchange);
 
 	for (ifa = TAILQ_FIRST(&ifp->if_addrhead); ifa;
--- //depot/vendor/freebsd/src/sys/net/if_var.h	2005/08/02 23:25:23
+++ //depot/projects/netsmp/src/sys/net/if_var.h	2005/08/04 17:25:23
@@ -422,6 +422,10 @@
 #define	IFQ_INC_DROPS(ifq)		((ifq)->ifq_drops++)
 #define	IFQ_SET_MAXLEN(ifq, len)	((ifq)->ifq_maxlen = (len))
 
+/*
+ * XXXRW: The IFF_DRV_OACTIVE test should really occur in the device driver,
+ * not in the handoff logic, as that flag is locked by the device driver.
+ */
 #define	IFQ_HANDOFF_ADJ(ifp, m, adj, err)				\
 do {									\
 	int len;							\
@@ -434,7 +438,7 @@
 		(ifp)->if_obytes += len + (adj);			\
 		if (mflags & M_MCAST)					\
 			(ifp)->if_omcasts++;				\
-		if (((ifp)->if_flags & IFF_OACTIVE) == 0)		\
+		if (((ifp)->if_drv_flags & IFF_DRV_OACTIVE) == 0)	\
 			if_start(ifp);					\
 	}								\
 } while (0)
--- //depot/vendor/freebsd/src/sys/net/if_vlan.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/net/if_vlan.c	2005/08/05 14:11:40
@@ -188,21 +188,36 @@
 	}
 
 	/* Now program new ones. */
+
+	/*
+	 * XXXRW: Really, this should happen in two steps, interlocked by the
+	 * vlan mutex (if any: first, the parent interface's address list
+	 * should be propagated to the softc, then from the softc to the
+	 * child, in order to avoid holding parent's and child's if_addr_mtx
+	 * at the same time.  Races can occur, but won't result in
+	 * incorrectness.  Assuming there is a vlan mutex.
+	 */
+	IF_ADDR_LOCK(ifp);
 	TAILQ_FOREACH(ifma, &ifp->if_multiaddrs, ifma_link) {
 		if (ifma->ifma_addr->sa_family != AF_LINK)
 			continue;
 		mc = malloc(sizeof(struct vlan_mc_entry), M_VLAN, M_NOWAIT);
-		if (mc == NULL)
+		if (mc == NULL) {
+			IF_ADDR_UNLOCK(ifp);
 			return (ENOMEM);
+		}
 		bcopy(LLADDR((struct sockaddr_dl *)ifma->ifma_addr),
 		    (char *)&mc->mc_addr, ETHER_ADDR_LEN);
 		SLIST_INSERT_HEAD(&sc->vlan_mc_listhead, mc, mc_entries);
 		bcopy(LLADDR((struct sockaddr_dl *)ifma->ifma_addr),
 		    LLADDR(&sdl), ETHER_ADDR_LEN);
 		error = if_addmulti(ifp_p, (struct sockaddr *)&sdl, &rifma);
-		if (error)
+		if (error) {
+			IF_ADDR_UNLOCK(ifp);
 			return (error);
+		}
 	}
+	IF_ADDR_UNLOCK(ifp);
 
 	return (0);
 }
@@ -413,7 +428,7 @@
 			return (error);
 		}
 		ifv->ifv_tag = tag;
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		VLAN_UNLOCK();
 
 		/* Update promiscuous mode, if necessary. */
@@ -467,7 +482,7 @@
 	ifv = ifp->if_softc;
 	p = ifv->ifv_p;
 
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 	for (;;) {
 		IF_DEQUEUE(&ifp->if_snd, m);
 		if (m == 0)
@@ -478,8 +493,8 @@
 		 * Do not run parent's if_start() if the parent is not up,
 		 * or parent's driver will cause a system crash.
 		 */
-		if ((p->if_flags & (IFF_UP | IFF_RUNNING)) !=
-					(IFF_UP | IFF_RUNNING)) {
+		if (!((p->if_flags & IFF_UP) &&
+		    (p->if_drv_flags & IFF_DRV_RUNNING))) {
 			m_freem(m);
 			ifp->if_collisions++;
 			continue;
@@ -550,7 +565,7 @@
 		else
 			ifp->if_oerrors++;
 	}
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 }
 
 static void
@@ -926,7 +941,7 @@
 			vlan_unconfig(ifp);
 			if (ifp->if_flags & IFF_UP)
 				if_down(ifp);
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 			VLAN_UNLOCK();
 			break;
 		}
@@ -950,7 +965,7 @@
 			break;
 		}
 		ifv->ifv_tag = vlr.vlr_tag;
-		ifp->if_flags |= IFF_RUNNING;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		VLAN_UNLOCK();
 
 		/* Update promiscuous mode, if necessary. */
--- //depot/vendor/freebsd/src/sys/net/ppp_tty.c	2005/07/01 15:25:28
+++ //depot/projects/netsmp/src/sys/net/ppp_tty.c	2005/08/05 14:11:40
@@ -207,7 +207,7 @@
     sc->sc_setmtu = pppasyncsetmtu;
     sc->sc_outm = NULL;
     pppgetm(sc);
-    PPP2IFP(sc)->if_flags |= IFF_RUNNING;
+    PPP2IFP(sc)->if_drv_flags |= IFF_DRV_RUNNING;
     getmicrotime(&PPP2IFP(sc)->if_lastchange);
     PPP2IFP(sc)->if_baudrate = tp->t_ospeed;
 
--- //depot/vendor/freebsd/src/sys/net/rtsock.c	2005/07/15 09:51:31
+++ //depot/projects/netsmp/src/sys/net/rtsock.c	2005/07/19 21:29:46
@@ -1178,6 +1178,11 @@
 			continue;
 		ifa = ifaddr_byindex(ifp->if_index);
 		info.rti_info[RTAX_IFP] = ifa ? ifa->ifa_addr : NULL;
+
+		/*
+		 * XXXRW: Can't acquire IF_ADDR_LOCK() due to call
+	 	 * to SYSCTL_OUT().
+		 */
 		TAILQ_FOREACH(ifma, &ifp->if_multiaddrs, ifma_link) {
 			if (af && af != ifma->ifma_addr->sa_family)
 				continue;
--- //depot/vendor/freebsd/src/sys/net80211/ieee80211_ioctl.c	2005/07/22 17:37:32
+++ //depot/projects/netsmp/src/sys/net80211/ieee80211_ioctl.c	2005/08/05 14:11:40
@@ -68,7 +68,8 @@
 #include <dev/wi/if_wavelan_ieee.h>
 
 #define	IS_UP(_ic) \
-	(((_ic)->ic_ifp->if_flags & (IFF_RUNNING|IFF_UP)) == (IFF_RUNNING|IFF_UP))
+	(((_ic)->ic_ifp->if_flags & IFF_UP) &&			\
+	    ((_ic)->ic_ifp->if_drv_flags & IFF_DRV_RUNNING))
 #define	IS_UP_AUTO(_ic) \
 	(IS_UP(_ic) && (_ic)->ic_roaming == IEEE80211_ROAMING_AUTO)
 
--- //depot/vendor/freebsd/src/sys/netatm/atm_if.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/netatm/atm_if.c	2005/08/05 14:11:40
@@ -518,7 +518,8 @@
 
 			if_initname(ifp, nip->nif_name, count);
 			ifp->if_mtu = ATM_NIF_MTU;
-			ifp->if_flags = IFF_UP | IFF_BROADCAST | IFF_RUNNING;
+			ifp->if_flags = IFF_UP | IFF_BROADCAST;
+			ifp->if_drv_flags = IFF_DRV_RUNNING;
 			ifp->if_output = atm_ifoutput;
 			ifp->if_ioctl = atm_if_ioctl;
 			ifp->if_snd.ifq_maxlen = ifqmaxlen;
@@ -992,7 +993,8 @@
 
 	case SIOCSIFADDR:
 		error = atm_nif_setaddr ( nip, (struct ifaddr *)data);
-		ifp->if_flags |= IFF_UP | IFF_RUNNING | IFF_BROADCAST;
+		ifp->if_flags |= IFF_UP | IFF_BROADCAST;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		break;
 
 	case SIOCGIFFLAGS:
--- //depot/vendor/freebsd/src/sys/netgraph/ng_eiface.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/netgraph/ng_eiface.c	2005/08/05 14:11:40
@@ -147,13 +147,14 @@
 		 * If it is marked down and running, then stop it.
 		 */
 		if (ifr->ifr_flags & IFF_UP) {
-			if (!(ifp->if_flags & IFF_RUNNING)) {
-				ifp->if_flags &= ~(IFF_OACTIVE);
-				ifp->if_flags |= IFF_RUNNING;
+			if (!(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
+				ifp->if_drv_flags &= ~(IFF_DRV_OACTIVE);
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 			}
 		} else {
-			if (ifp->if_flags & IFF_RUNNING)
-				ifp->if_flags &= ~(IFF_RUNNING | IFF_OACTIVE);
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING)
+				ifp->if_drv_flags &= ~(IFF_DRV_RUNNING |
+				    IFF_DRV_OACTIVE);
 		}
 		break;
 
@@ -192,8 +193,8 @@
 
 	s = splimp();
 
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	splx(s);
 }
@@ -212,14 +213,16 @@
 	struct mbuf *m;
 
 	/* Check interface flags */
-	if ((ifp->if_flags & (IFF_UP | IFF_RUNNING)) != (IFF_UP | IFF_RUNNING))
+
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		return;
 
 	/* Don't do anything if output is active */
-	if (ifp->if_flags & IFF_OACTIVE)
+	if (ifp->if_drv_flags & IFF_DRV_OACTIVE)
 		return;
 
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 
 	/*
 	 * Grab a packet to transmit.
@@ -228,7 +231,7 @@
 
 	/* If there's nothing to send, return. */
 	if (m == NULL) {
-		ifp->if_flags &= ~IFF_OACTIVE;
+		ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 		return;
 	}
 
@@ -254,7 +257,7 @@
 		ifp->if_opackets++;
 	}
 
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	return;
 }
@@ -523,8 +526,8 @@
 	NGI_GET_M(item, m);
 	NG_FREE_ITEM(item);
 
-	if ((ifp->if_flags & (IFF_UP | IFF_RUNNING)) !=
-	    (IFF_UP | IFF_RUNNING)) {
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 		NG_FREE_M(m);
 		return (ENETDOWN);
 	}
--- //depot/vendor/freebsd/src/sys/netgraph/ng_ether.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/netgraph/ng_ether.c	2005/08/05 14:11:40
@@ -601,7 +601,8 @@
  	struct ifnet *const ifp = priv->ifp;
 
 	/* Check whether interface is ready for packets */
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 		NG_FREE_M(m);
 		return (ENETDOWN);
 	}
--- //depot/vendor/freebsd/src/sys/netgraph/ng_fec.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/netgraph/ng_fec.c	2005/08/05 14:11:40
@@ -637,7 +637,7 @@
 	}
 
 	ifp = priv->ifp;
-	if (ifp->if_flags & IFF_RUNNING)
+	if (ifp->if_drv_flags & IFF_DRV_RUNNING)
 		priv->fec_ch = timeout(ng_fec_tick, priv, hz);
 
 	return;
@@ -704,7 +704,7 @@
 		 * If it is marked down and running, then stop it.
 		 */
 		if (ifr->ifr_flags & IFF_UP) {
-			if (!(ifp->if_flags & IFF_RUNNING)) {
+			if (!(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 				/* Sanity. */
 				if (b->fec_ifcnt == 1 || b->fec_ifcnt == 3) {
 					printf("fec%d: invalid bundle "
@@ -713,8 +713,8 @@
 					error = EINVAL;
 					break;
 				}
-				ifp->if_flags &= ~(IFF_OACTIVE);
-				ifp->if_flags |= IFF_RUNNING;
+				ifp->if_drv_flags &= ~(IFF_DRV_OACTIVE);
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 				ng_fec_init(ifp);
 			}
 			/*
@@ -727,8 +727,9 @@
 				priv->if_flags = ifp->if_flags;
 			}
 		} else {
-			if (ifp->if_flags & IFF_RUNNING)
-				ifp->if_flags &= ~(IFF_RUNNING | IFF_OACTIVE);
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING)
+				ifp->if_drv_flags &= ~(IFF_DRV_RUNNING |
+				    IFF_DRV_OACTIVE);
 			ng_fec_stop(ifp);
 		}
 		break;
@@ -834,7 +835,8 @@
 	int error;
 
 	/* Check interface flags */
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 		m_freem(m);
 		return (ENETDOWN);
 	}
--- //depot/vendor/freebsd/src/sys/netgraph/ng_iface.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/netgraph/ng_iface.c	2005/08/05 14:11:40
@@ -290,8 +290,9 @@
 
 	/* These two are mostly handled at a higher layer */
 	case SIOCSIFADDR:
-		ifp->if_flags |= (IFF_UP | IFF_RUNNING);
-		ifp->if_flags &= ~(IFF_OACTIVE);
+		ifp->if_flags |= IFF_UP;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
+		ifp->if_drv_flags &= ~(IFF_DRV_OACTIVE);
 		break;
 	case SIOCGIFADDR:
 		break;
@@ -303,13 +304,14 @@
 		 * If it is marked down and running, then stop it.
 		 */
 		if (ifr->ifr_flags & IFF_UP) {
-			if (!(ifp->if_flags & IFF_RUNNING)) {
-				ifp->if_flags &= ~(IFF_OACTIVE);
-				ifp->if_flags |= IFF_RUNNING;
+			if (!(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
+				ifp->if_drv_flags &= ~(IFF_DRV_OACTIVE);
+				ifp->if_drv_flags |= IFF_DRV_RUNNING;
 			}
 		} else {
-			if (ifp->if_flags & IFF_RUNNING)
-				ifp->if_flags &= ~(IFF_RUNNING | IFF_OACTIVE);
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING)
+				ifp->if_drv_flags &= ~(IFF_DRV_RUNNING |
+				    IFF_DRV_OACTIVE);
 		}
 		break;
 
@@ -355,7 +357,8 @@
 	u_int32_t af;
 
 	/* Check interface flags */
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 		m_freem(m);
 		return (ENETDOWN);
 	}
@@ -628,10 +631,10 @@
 	case NGM_FLOW_COOKIE:
 		switch (msg->header.cmd) {
 		case NGM_LINK_IS_UP:
-			ifp->if_flags |= IFF_RUNNING;
+			ifp->if_drv_flags |= IFF_DRV_RUNNING;
 			break;
 		case NGM_LINK_IS_DOWN:
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 			break;
 		default:
 			break;
--- //depot/vendor/freebsd/src/sys/netgraph/ng_sppp.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/netgraph/ng_sppp.c	2005/08/05 14:11:40
@@ -205,17 +205,18 @@
 	 * are not UP. If we are not running we still want to send LCP term
 	 * packets.
 	 */
-/*	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {*/
+/*	if (!((ifp->if_flags & IFF_UP) && */
+/*	    (ifp->if_drv_flags & IFF_DRV_RUNNING))) { */
 /*		return;*/
 /*	}*/
 	
-	if (ifp->if_flags & IFF_OACTIVE)
+	if (ifp->if_drv_flags & IFF_DRV_OACTIVE)
 		return;
 		
 	if (!priv->hook)
 		return;
 		
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 
 	while ((m = sppp_dequeue (ifp)) != NULL) {
 		if (ifp->if_bpf)
@@ -225,11 +226,11 @@
 		NG_SEND_DATA_ONLY (error, priv->hook, m);
 		
 		if (error) {
-			ifp->if_flags &= ~IFF_OACTIVE;
+			ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 			return;
 		}
 	}
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 }
 
 /************************************************************************
--- //depot/vendor/freebsd/src/sys/netinet/ip_carp.c	2005/07/25 12:37:23
+++ //depot/projects/netsmp/src/sys/netinet/ip_carp.c	2005/08/05 14:11:40
@@ -628,8 +628,8 @@
 		if (sc->sc_vhid == ch->carp_vhid)
 			break;
 
-	if (!sc || (SC2IFP(sc)->if_flags & (IFF_UP|IFF_RUNNING)) !=
-	    (IFF_UP|IFF_RUNNING)) {
+	if (!sc || !((SC2IFP(sc)->if_flags & IFF_UP) &&
+	    (SC2IFP(sc)->if_drv_flags & IFF_DRV_RUNNING))) {
 		carpstats.carps_badvhid++;
 		CARP_UNLOCK(ifp->if_carp);
 		m_freem(m);
@@ -828,7 +828,8 @@
 		if (sc->sc_carpdev == NULL)
 			continue;
 		CARP_SCLOCK(sc);
-		if ((SC2IFP(sc)->if_flags & (IFF_UP|IFF_RUNNING)) &&
+		if ((SC2IFP(sc)->if_flags & IFF_UP) &&
+		    (SC2IFP(sc)->if_drv_flags & IFF_DRV_RUNNING) &&
 		     sc->sc_state == MASTER)
 			carp_send_ad_locked(sc);
 		CARP_SCUNLOCK(sc);
@@ -858,8 +859,8 @@
 	CARP_SCLOCK_ASSERT(sc);
 
 	/* bow out if we've lost our UPness or RUNNINGuiness */
-	if ((SC2IFP(sc)->if_flags &
-	    (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+	if (!((SC2IFP(sc)->if_flags & IFF_UP) &&
+	    (SC2IFP(sc)->if_drv_flags & IFF_DRV_RUNNING))) {
 		advbase = 255;
 		advskew = 255;
 	} else {
@@ -1086,8 +1087,8 @@
 
 	TAILQ_FOREACH(vh, &cif->vhif_vrs, sc_list) {
 		if ((type == CARP_COUNT_RUNNING &&
-		    (SC2IFP(vh)->if_flags & (IFF_UP|IFF_RUNNING)) ==
-		    (IFF_UP|IFF_RUNNING)) ||
+		    (SC2IFP(vh)->if_flags & IFF_UP) &&
+		    (SC2IFP(vh)->if_drv_flags & IFF_DRV_RUNNING)) ||
 		    (type == CARP_COUNT_MASTER && vh->sc_state == MASTER)) {
 			TAILQ_FOREACH(ifa, &SC2IFP(vh)->if_addrlist,
 			    ifa_list) {
@@ -1132,8 +1133,8 @@
 		count = 0;
 
 		TAILQ_FOREACH(vh, &cif->vhif_vrs, sc_list) {
-			if ((SC2IFP(vh)->if_flags & (IFF_UP|IFF_RUNNING)) ==
-			    (IFF_UP|IFF_RUNNING)) {
+			if ((SC2IFP(vh)->if_flags & IFF_UP) &&
+			    (SC2IFP(vh)->if_drv_flags & IFF_DRV_RUNNING)) {
 				TAILQ_FOREACH(ifa, &SC2IFP(vh)->if_addrlist,
 				    ifa_list) {
 					if (ifa->ifa_addr->sa_family ==
@@ -1158,9 +1159,9 @@
 		}
 	} else {
 		TAILQ_FOREACH(vh, &cif->vhif_vrs, sc_list) {
-			if ((SC2IFP(vh)->if_flags & (IFF_UP|IFF_RUNNING)) ==
-			    (IFF_UP|IFF_RUNNING) && ia->ia_ifp ==
-			    SC2IFP(vh)) {
+			if ((SC2IFP(vh)->if_flags & IFF_UP) &&
+			    (SC2IFP(vh)->if_drv_flags & IFF_DRV_RUNNING) &&
+			    ia->ia_ifp == SC2IFP(vh)) {
 				*enaddr = IFP2ENADDR(vh->sc_ifp);
 				CARP_UNLOCK(cif);
 				return (1);
@@ -1184,8 +1185,8 @@
 		TAILQ_FOREACH(ifa, &SC2IFP(vh)->if_addrlist, ifa_list) {
 			if (IN6_ARE_ADDR_EQUAL(taddr,
 			    &ifatoia6(ifa)->ia_addr.sin6_addr) &&
- 			    ((SC2IFP(vh)->if_flags &
-			    (IFF_UP|IFF_RUNNING)) == (IFF_UP|IFF_RUNNING))) {
+ 			    (SC2IFP(vh)->if_flags & IFF_UP) &&
+			    (SC2IFP(vh)->if_drv_flags & IFF_DRV_RUNNING)) {
 			    	CARP_UNLOCK(cif);
 				return (ifa);
 			}
@@ -1209,8 +1210,8 @@
 		TAILQ_FOREACH(ifa, &SC2IFP(sc)->if_addrlist, ifa_list) {
 			if (IN6_ARE_ADDR_EQUAL(taddr,
 			    &ifatoia6(ifa)->ia_addr.sin6_addr) &&
- 			    ((SC2IFP(sc)->if_flags &
-			    (IFF_UP|IFF_RUNNING)) == (IFF_UP|IFF_RUNNING))) {	
+ 			    (SC2IFP(sc)->if_flags & IFF_UP) &&
+			    (SC2IFP(sc)->if_drv_flags & IFF_DRV_RUNNING)) {
 				struct ifnet *ifp = SC2IFP(sc);
 				mtag = m_tag_get(PACKET_TAG_CARP,
 				    sizeof(struct ifnet *), M_NOWAIT);
@@ -1246,8 +1247,9 @@
 
 	CARP_LOCK(cif);
 	TAILQ_FOREACH(vh, &cif->vhif_vrs, sc_list)
-		if ((SC2IFP(vh)->if_flags & (IFF_UP|IFF_RUNNING)) ==
-		    (IFF_UP|IFF_RUNNING) && vh->sc_state == MASTER &&
+		if ((SC2IFP(vh)->if_flags & IFF_UP) &&
+		    (SC2IFP(vh)->if_drv_flags & IFF_DRV_RUNNING) &&
+		    vh->sc_state == MASTER &&
 		    !bcmp(dhost, IFP2ENADDR(vh->sc_ifp), ETHER_ADDR_LEN)) {
 		    	CARP_UNLOCK(cif);
 			return (SC2IFP(vh));
@@ -1307,9 +1309,9 @@
 
 	if (SC2IFP(sc)->if_flags & IFF_UP &&
 	    sc->sc_vhid > 0 && (sc->sc_naddrs || sc->sc_naddrs6))
-		SC2IFP(sc)->if_flags |= IFF_RUNNING;
+		SC2IFP(sc)->if_drv_flags |= IFF_DRV_RUNNING;
 	else {
-		SC2IFP(sc)->if_flags &= ~IFF_RUNNING;
+		SC2IFP(sc)->if_drv_flags &= ~IFF_DRV_RUNNING;
 		carp_setroute(sc, RTM_DELETE);
 		return;
 	}
@@ -1511,7 +1513,8 @@
 
 		CARP_LOCK(cif);
 		callout_stop(&sc->sc_ad_tmo);
-		SC2IFP(sc)->if_flags &= ~(IFF_UP|IFF_RUNNING);
+		SC2IFP(sc)->if_flags &= ~IFF_UP;
+		SC2IFP(sc)->if_drv_flags &= ~IFF_DRV_RUNNING;
 		sc->sc_vhid = -1;
 		in_delmulti(imo->imo_membership[--imo->imo_num_memberships]);
 		imo->imo_multicast_ifp = NULL;
@@ -1700,7 +1703,8 @@
 
 		CARP_LOCK(cif);
 		callout_stop(&sc->sc_ad_tmo);
-		SC2IFP(sc)->if_flags &= ~(IFF_UP|IFF_RUNNING);
+		SC2IFP(sc)->if_flags &= ~IFF_UP;
+		SC2IFP(sc)->if_drv_flags &= ~IFF_DRV_RUNNING;
 		sc->sc_vhid = -1;
 		while (!LIST_EMPTY(&im6o->im6o_memberships)) {
 			struct in6_multi_mship *imm =
@@ -2096,7 +2100,8 @@
 	if (sc->sc_carpdev->if_link_state != LINK_STATE_UP ||
 	    !(sc->sc_carpdev->if_flags & IFF_UP)) {
 		sc->sc_flags_backup = SC2IFP(sc)->if_flags;
-		SC2IFP(sc)->if_flags &= ~(IFF_UP|IFF_RUNNING);
+		SC2IFP(sc)->if_flags &= ~IFF_UP;
+		SC2IFP(sc)->if_drv_flags &= ~IFF_DRV_RUNNING;
 		callout_stop(&sc->sc_ad_tmo);
 		callout_stop(&sc->sc_md_tmo);
 		callout_stop(&sc->sc_md6_tmo);
--- //depot/vendor/freebsd/src/sys/netinet/ip_fastfwd.c	2005/07/23 01:00:54
+++ //depot/projects/netsmp/src/sys/netinet/ip_fastfwd.c	2005/08/05 14:11:40
@@ -129,7 +129,7 @@
 	rt = ro->ro_rt;
 	if (rt && (rt->rt_flags & RTF_UP) &&
 	    (rt->rt_ifp->if_flags & IFF_UP) &&
-	    (rt->rt_ifp->if_flags & IFF_RUNNING)) {
+	    (rt->rt_ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 		if (rt->rt_flags & RTF_GATEWAY)
 			dst = (struct sockaddr_in *)rt->rt_gateway;
 	} else {
--- //depot/vendor/freebsd/src/sys/netinet6/in6.c	2005/07/25 12:35:27
+++ //depot/projects/netsmp/src/sys/netinet6/in6.c	2005/08/05 14:11:40
@@ -1993,8 +1993,8 @@
 		 * XXX: we should rather mark "tentative" on such addresses,
 		 * and do DAD after the interface becomes ready.
 		 */
-		if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) !=
-		    (IFF_UP|IFF_RUNNING))
+		if (!((ifp->if_flags & IFF_UP) &&
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 			return (0);
 
 		return (1);
--- //depot/vendor/freebsd/src/sys/netinet6/nd6_nbr.c	2005/07/25 12:35:27
+++ //depot/projects/netsmp/src/sys/netinet6/nd6_nbr.c	2005/08/05 14:11:40
@@ -1371,7 +1371,7 @@
 #endif
 		return;
 	}
-	if ((ifp->if_flags & IFF_RUNNING) == 0) {
+	if ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 #if 0
 		printf("%s: interface not running?\n", if_name(ifp));
 #endif
--- //depot/vendor/freebsd/src/sys/netnatm/natm.c	2005/07/19 13:37:24
+++ //depot/projects/netsmp/src/sys/netnatm/natm.c	2005/08/05 14:11:40
@@ -178,7 +178,7 @@
      * convert interface string to ifp, validate.
      */
     ifp = ifunit(snatm->snatm_if);
-    if (ifp == NULL || (ifp->if_flags & IFF_RUNNING) == 0) {
+    if (ifp == NULL || (ifp->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 	error = ENXIO;
 	goto out;
     }
--- //depot/vendor/freebsd/src/sys/pci/if_dc.c	2005/08/03 00:20:47
+++ //depot/projects/netsmp/src/sys/pci/if_dc.c	2005/08/05 14:11:40
@@ -1330,7 +1330,7 @@
 
 	DC_SETBIT(sc, DC_NETCFG, DC_NETCFG_TX_ON);
 	DC_SETBIT(sc, DC_NETCFG, DC_NETCFG_RX_ON);
-	ifp->if_flags |= IFF_RUNNING;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	sframe->dc_status = htole32(DC_TXSTAT_OWN);
 	CSR_WRITE_4(sc, DC_TXSTART, 0xFFFFFFFF);
 
@@ -2908,7 +2908,7 @@
 	if (idx != sc->dc_cdata.dc_tx_cons) {
 	    	/* Some buffers have been freed. */
 		sc->dc_cdata.dc_tx_cons = idx;
-		ifp->if_flags &= ~IFF_OACTIVE;
+		ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	}
 	ifp->if_timer = (sc->dc_cdata.dc_tx_cnt == 0) ? 0 : 5;
 }
@@ -3057,7 +3057,8 @@
 	sc->rxcycles = count;
 	dc_rxeof(sc);
 	dc_txeof(sc);
-	if (!IFQ_IS_EMPTY(&ifp->if_snd) && !(ifp->if_flags & IFF_OACTIVE))
+	if (!IFQ_IS_EMPTY(&ifp->if_snd) &&
+	    !(ifp->if_drv_flags & IFF_DRV_OACTIVE))
 		dc_start(ifp);
 
 	if (cmd == POLL_AND_CHECK_STATUS) { /* also check status register */
@@ -3328,7 +3329,7 @@
 		return;
 	}
 
-	if (ifp->if_flags & IFF_OACTIVE) {
+	if (ifp->if_drv_flags & IFF_DRV_OACTIVE) {
 		DC_UNLOCK(sc);
 		return;
 	}
@@ -3346,7 +3347,7 @@
 			m = m_defrag(m_head, M_DONTWAIT);
 			if (m == NULL) {
 				IFQ_DRV_PREPEND(&ifp->if_snd, m_head);
-				ifp->if_flags |= IFF_OACTIVE;
+				ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 				break;
 			} else {
 				m_head = m;
@@ -3355,7 +3356,7 @@
 
 		if (dc_encap(sc, &m_head)) {
 			IFQ_DRV_PREPEND(&ifp->if_snd, m_head);
-			ifp->if_flags |= IFF_OACTIVE;
+			ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 			break;
 		}
 		idx = sc->dc_cdata.dc_tx_prod;
@@ -3368,7 +3369,7 @@
 		BPF_MTAP(ifp, m_head);
 
 		if (sc->dc_flags & DC_TX_ONE) {
-			ifp->if_flags |= IFF_OACTIVE;
+			ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 			break;
 		}
 	}
@@ -3550,8 +3551,8 @@
 	mii_mediachg(mii);
 	dc_setcfg(sc, sc->dc_if_media);
 
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	/* Don't start the ticker if this is a homePNA link. */
 	if (IFM_SUBTYPE(mii->mii_media.ifm_media) == IFM_HPNA_1)
@@ -3640,7 +3641,7 @@
 			int need_setfilt = (ifp->if_flags ^ sc->dc_if_flags) &
 				(IFF_PROMISC | IFF_ALLMULTI);
 
-			if (ifp->if_flags & IFF_RUNNING) {
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING) {
 				if (need_setfilt)
 					dc_setfilt(sc);
 			} else {
@@ -3648,7 +3649,7 @@
 				dc_init(sc);
 			}
 		} else {
-			if (ifp->if_flags & IFF_RUNNING)
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING)
 				dc_stop(sc);
 		}
 		sc->dc_if_flags = ifp->if_flags;
@@ -3726,7 +3727,7 @@
 
 	callout_stop(&sc->dc_stat_ch);
 
-	ifp->if_flags &= ~(IFF_RUNNING | IFF_OACTIVE);
+	ifp->if_drv_flags &= ~(IFF_DRV_RUNNING | IFF_DRV_OACTIVE);
 #ifdef DEVICE_POLLING
 	ether_poll_deregister(ifp);
 #endif
